#include <stdio.h>
#include <stdlib.h>

#include <math.h>

#include "graph.h"
#include "pnmread.h"

#if 0
typedef Graph<int,int,int> GraphType; 
#endif
typedef Graph<float,float,float> GraphType;


#ifndef sqr
#define sqr(x) ((x) * (x))
#endif

#ifndef abs
#define abs(x) (((x) >= 0) ? (x) : -(x))
#endif

#ifndef maximum
#define maximum(x,y) (((x)<(y)) ? (y) : (x))
#endif

#ifndef minimum
#define minimum(x,y) (((x)<(y)) ? (x) : (y))
#endif



#define C   1    
#define NUM_OF_HIERARCHY 64
#define MASKSIZE         4  /* (2*MASKSIZE+1)*(2*MASKSIZE+1):costFunction.c */


#define _SAD          1     /* Sum of Absolute Difference : costFunction.c */
#define _SSD          2     /* Sum of Squared  Difference : costFunction.c */
#define _CORRELATION  3     /* Correlation                : costFunction.c */

#define COST_TYPE     1     /* Use calc Diffrence in calcDataCost */


typedef unsigned char uchar;

typedef struct _label
{
  int *label;
  int  num;
}LABEL;


/*** Prototypes ***/
float D(double fp, double lp);
int   V(double fp, double fq);
int searchLabelNum(LABEL A, int beta);
float calcDataCost(PGM *img1, PGM *img2, int x, int y, int disparity, int width, int height);
float SAD(PGM *img1, PGM *img2, int x, int y, int disparity, int width, int height);
float SSD(PGM *img1, PGM *img2, int x, int y, int disparity, int width, int height);

int* hierarchicalGraphCut(PGM *img1, PGM *img2, int width, int height, int maxval);

LABEL *calcHierarchicalLabel(void);
void FreeHierarchicalLabel(LABEL *l);
void printHierarchicalLabel(LABEL *l);
int checkHierarchicalLabel(LABEL *l);
int mypow(int x, int n);


